## tidy-html5 5.8.0

=== CMakeLists.txt ===
##############################################################################
# @file CMakeLists.txt
# Build executables, static and dylibs, packages, build systems, etc., for
# HTML Tidy.
#
# Read this file or use cmake-gui (Windows) or ccmake (everything else) for
# guided build.
#
# @author  Geoff McLane [ubuntu@geoffair.info]
# @author  HTACG, et al (consult git log)
#
# @copyright
#          Copyright (c) 1998-2017 HTACG
# @copyright
#          See tidy.h for license.
#
# @date    Consult git log.
##############################################################################

cmake_minimum_required (VERSION 2.8.12)

set(LIB_NAME tidy)
set(LIBTIDY_DESCRIPTION "${LIB_NAME} - HTML syntax checker")
set(LIBTIDY_URL "http://www.html-tidy.org")

project (${LIB_NAME})


#################################################
# Setup
#################################################

#------------------------------------------------------------------------
# Release Information
#   Release version and date are found in `version.txt`; update *that*
#   file when required. It will be read into variable `versionFile`
#   (stripping any newlines or spaces). This file must be formatted into
#   two lines: the dot-separated MAJOR.MINOR.POINT version, followed by
#   the date separated YEAR.MONTH.DAY release date.
#------------------------------------------------------------------------
file(READ version.txt versionFile)

if (NOT versionFile)
    message(FATAL_ERROR "Unable to determine libtidy version. version.txt file is missing.")
endif()

string(STRIP "${versionFile}" VERSION_TEXT)
string(REGEX REPLACE "(.*)[\r\n|\n](.*)" "\\1" LIBTIDY_VERSION ${VERSION_TEXT})
string(REGEX REPLACE "(.*)[\r\n|\n](.*)" "\\2" LIBTIDY_DATE ${VERSION_TEXT})

# Establish version number
if (LIBTIDY_VERSION)
    string(REPLACE "." ";" VERSION_LIST ${LIBTIDY_VERSION})
    list(GET VERSION_LIST 0 TIDY_MAJOR_VERSION)
    list(GET VERSION_LIST 1 TIDY_MINOR_VERSION)
    list(GET VERSION_LIST 2 TIDY_POINT_VERSION)
    set(TIDY_SO_VERSION "${TIDY_MAJOR_VERSION}${TIDY_MINOR_VERSION}")
else ()
    message(FATAL_ERROR "*** FAILED to get a VERSION from version.txt!")
endif ()   
 
# Establish version date
if (LIBTIDY_DATE)
    string(REPLACE "." ";" DATE_LIST ${LIBTIDY_DATE})
    list(GET DATE_LIST 0 tidy_YEAR)
    list(GET DATE_LIST 1 tidy_MONTH)
    list(GET DATE_LIST 2 tidy_DAY)
else ()
    message(FATAL_ERROR "*** FAILED to get a DATE from version.txt!")
endif ()

# Establish SOVERSION. Tidy uses a weird form of semantic versioning,
# wherein even minor versions are stable versions with SONAMEs, and
# odd minor versions are `next` versions that should NOT be released,
# are NOT stable, and should NOT have a valid SONAME.
if (TIDY_SO_VERSION)
    math(EXPR NO_SONAME "${TIDY_SO_VERSION} % 2")
    if ( NO_SONAME EQUAL 0)
        message("-> TIDY_SO_VERSION = ${TIDY_SO_VERSION}. This is an EVEN (stable) release.")
    else ()
        message("-> TIDY_SO_VERSION = ${TIDY_SO_VERSION}. This is an ODD (development) release.")
    endif ()
else ()
    message(FATAL_ERROR "*** FAILED to build a TIDY_SO_VERSION!")
endif ()


#------------------------------------------------------------------------
# Library Types and Linking
#   By default, *both* static and dynamic library types are built. The
#   shared library can be turned off if not needed. The console program
#   can be configured for static linking or dynamic linking.
#------------------------------------------------------------------------
set( LIB_TYPE STATIC )  # set default message

option( BUILD_SHARED_LIB "Set OFF to NOT build shared library"     ON  )

# Issue #326 - Allow linkage choice of console app tidy
option( TIDY_CONSOLE_SHARED "Set ON to link with shared(DLL) lib." OFF )

if (TIDY_CONSOLE_SHARED)
    if (NOT BUILD_SHARED_LIB)
        message(FATAL_ERROR "Enable shared build for this tidy linkage!")
    endif ()
endif ()


#------------------------------------------------------------------------
# Miscellaneous Options
#------------------------------------------------------------------------
option( BUILD_TAB2SPACE     "Set ON to build utility app, tab2space"  OFF )
option( BUILD_SAMPLE_CODE   "Set ON to build the sample code"         OFF )
option( TIDY_COMPAT_HEADERS "Set ON to include compatibility headers" OFF )


#------------------------------------------------------------------------
# Man Page
#   Allow building with non-default man page directory.
#------------------------------------------------------------------------
if (NOT MAN_INSTALL_DIR)
    set(MAN_INSTALL_DIR share/man/man1)
endif ()


#------------------------------------------------------------------------
# Localization
#   Allow building without extra language support.
#------------------------------------------------------------------------
option( SUPPORT_LOCALIZATIONS "Set OFF to build without additional languages." ON )

if (SUPPORT_LOCALIZATIONS)
    add_definitions ( -DSUPPORT_LOCALIZATIONS=1 )
else ()
    add_definitions ( -DSUPPORT_LOCALIZATIONS=0 )
endif ()


#------------------------------------------------------------------------
# Console Application
#   Allow building without console support, which mostly prevents
#   console strings from existing in the library. Note that this will
#   prevent the console application from being built, since it can't be
#   linked.
#------------------------------------------------------------------------
option( SUPPORT_CONSOLE_APP "Set OFF to build libraries only without console application support." ON )

if (SUPPORT_CONSOLE_APP)
    add_definitions ( -DSUPPORT_CONSOLE_APP=1 )
else ()
    add_definitions ( -DSUPPORT_CONSOLE_APP=0 )
endif ()


#------------------------------------------------------------------------
# Diagnostics
#   Enable building with logs, some memory diagnostics.
#------------------------------------------------------------------------
option( ENABLE_DEBUG_LOG    "Set ON to output debugging messages."          OFF )
option( ENABLE_ALLOC_DEBUG  "Set ON to output node allocation diagnostics." OFF )
option( ENABLE_MEMORY_DEBUG "Set ON to output some memory diagnostics."     OFF )

if ( ENABLE_DEBUG_LOG )
    add_definitions( -DENABLE_DEBUG_LOG )
    message(STATUS "*** Debug Logging is enabled.")  
else ()
    message(STATUS "*** Debug Logging is NOT enabled.")  
endif ()

if (ENABLE_ALLOC_DEBUG)
    add_definitions ( -DDEBUG_ALLOCATION )  # see lexer.c for details
    message(STATUS "*** Note, lexer.c node allocation diagnostics are ON")
endif ()
    
if (ENABLE_MEMORY_DEBUG)
    add_definitions ( -DDEBUG_MEMORY )  # see alloc.c for details
    message(STATUS "*** Note, alloc.c memory diagnostics are ON")
endif ()
    
if (WIN32)
    option( ENABLE_CRTDBG_MEMORY "Set ON to enable the Windows CRT debug library." OFF )
    
    if (ENABLE_CRTDBG_MEMORY)
        add_definitions ( -D_CRTDBG_MAP_ALLOC )  # see tidy.c for details
        message(STATUS "*** Note, tidy.c Windows CRT memory debug is ON")
    endif ()
endif ()


#------------------------------------------------------------------------
# Complier Flags
#   Setup other compiler-specific and platform-specific compiler flags.
#------------------------------------------------------------------------
if(CMAKE_COMPILER_IS_GNUCXX)
    set( WARNING_FLAGS -Wall )
endif(CMAKE_COMPILER_IS_GNUCXX)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang") 
   set( WARNING_FLAGS "-Wall -Wno-overloaded-virtual" )
endif() 

if(WIN32 AND MSVC)
    # C4996: The compiler encountered a deprecated declaration.
    # C4090: 'function' : different 'const' qualifiers
    # C4244: '=' : conversion from '__int64' to 'uint', possible loss of data
    # C4267: 'function' : conversion from 'size_t' to 'uint', possible loss of data
    foreach(warning 4996 4090 4244 4267)
        set(WARNING_FLAGS "${WARNING_FLAGS} /wd${warning}")
    endforeach()
    
    set( MSVC_FLAGS "-DNOMINMAX -D_USE_MATH_DEFINES -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS -D__CRT_NONSTDC_NO_WARNINGS" )

    # to distinguish between debug and release lib in windows
    set( CMAKE_DEBUG_POSTFIX "d" ) # little effect in unix
else()
    # add any gcc flags
endif()

set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${WARNING_FLAGS} ${MSVC_FLAGS} -D_REENTRANT" )
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_FLAGS} ${MSVC_FLAGS} -D_REENTRANT" )
set( CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${MSVC_LD_FLAGS}" )


#------------------------------------------------------------------------
# Static Windows Runtime
#   Option to statically link to the Windows runtime. Maybe only 
#   applies to WIN32/MSVC.
#------------------------------------------------------------------------
if (MSVC)
    option( USE_STATIC_RUNTIME "Set ON to change /MD(DLL) to /MT(static)" OFF )
    if (USE_STATIC_RUNTIME)
        set(CompilerFlags
            CMAKE_CXX_FLAGS
            CMAKE_CXX_FLAGS_DEBUG
            CMAKE_CXX_FLAGS_RELEASE
            CMAKE_C_FLAGS
            CMAKE_C_FLAGS_DEBUG
            CMAKE_C_FLAGS_RELEASE
            )
        foreach(CompilerFlag ${CompilerFlags})
            string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
        endforeach()    
        message(STATUS "Using /MT STATIC runtime")
    else ()
        message(STATUS "Using /MD DYNAMIC runtime")
    endif ()
endif ()


#------------------------------------------------------------------------
# Macro Values
#   These additional macros are set in Tidy's source code. It is *very*
#   seldom that you would ever have to change any of these in order to
#   achieve a functioning build.
#------------------------------------------------------------------------
add_definitions ( -DLIBTIDY_VERSION="${LIBTIDY_VERSION}" )
add_definitions ( -DRELEASE_DATE="${tidy_YEAR}/${tidy_MONTH}/${tidy_DAY}" )

# Optionally specify an extra version point for pre-release/debug versions.
if (TIDY_RC_NUMBER)
    add_definitions ( -DRC_NUMBER="${TIDY_RC_NUMBER}" )
endif ()

# If your OS doesn't have native ISO2022 support, then build with this flag.
if (NO_NATIVE_ISO2022_SUPPORT)
    add_definitions ( -DNO_NATIVE_ISO2022_SUPPORT=1 )
endif ()

# If your OS doesn't have library function access(), build with this flag.
if (NO_ACCESS_SUPPORT)
    add_definitions ( -DNO_ACCESS_SUPPORT=1 )
endif ()

# Delete me? Not used in Tidy source!
add_definitions ( -DHAVE_CONFIG_H ) 


#------------------------------------------------------------------------
# Runtime Configuration File Support
#   By default on Unix-like systems when building for the console program,
#   support runtime configuration files in /etc/ and in ~/. To prevent this,
#   set ENABLE_CONFIG_FILES to NO. Specify -DTIDY_CONFIG_FILE and/or 
#   -DTIDY_USER_CONFIG_FILE to override the default paths in tidyplatform.h.
# @note: this section refactored to support #584.
#------------------------------------------------------------------------
if ( UNIX AND SUPPORT_CONSOLE_APP )

  option ( ENABLE_CONFIG_FILES "Set to OFF to disable Tidy runtime configuration file support" ON )

    # All Unixes support getpwnam(); undef'd in tidyplatform.h if necessary.
    add_definitions( -DSUPPORT_GETPWNAM=1 )

else ()

  option ( ENABLE_CONFIG_FILES "Set to ON to enable Tidy runtime configuration file support" OFF )
  
  if ( SUPPORT_GETPWNAM )
    add_definitions( -DSUPPORT_GETPWNAM=1 )
  endif ()
  
endif ()

if ( ENABLE_CONFIG_FILES )

    message(STATUS "*** Building support for runtime configuration files.")

    add_definitions( -DTIDY_ENABLE_CONFIG_FILES )
    
    # define a default here so we can pass to XSL.
    if ( NOT TIDY_CONFIG_FILE )
        set( TIDY_CONFIG_FILE "/etc/tidy.conf" )
    endif ()

    # define a default here so we can pass to XSL.
    if ( NOT TIDY_USER_CONFIG_FILE )
        set( TIDY_USER_CONFIG_FILE "~/.tidyrc" )
    endif ()

    # do *not* add these unless ENABLE_CONFIG_FILES!
    add_definitions( -DTIDY_CONFIG_FILE="${TIDY_CONFIG_FILE}" )

=== debian/changelog ===
tidy-html5 (2:5.8.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4 (Closes: #1113573)

 -- Timo Röhling <roehling@debian.org>  Sun, 09 Nov 2025 21:20:07 +0100

tidy-html5 (2:5.8.0-2) unstable; urgency=high

  * [CVE-2021-33391]: Fix an upstream issue that allows attacker to
    execute arbitrary code via the -g option of the CleanNode() function
    in gdoc.c.

 -- Ondřej Surý <ondrej@debian.org>  Sun, 27 Apr 2025 12:22:24 +0200

tidy-html5 (2:5.8.0-1) unstable; urgency=medium

  [ Ondřej Surý ]
  * Upload to unstable.
  * Fix d/watch to consider only stable releases
  * Acknowledge orphan by Boyuang (Closes: #1075781); thank for everything
  * Add d/gbp.conf for pristine-tar

  [ Debian Janitor ]
  * Trim trailing whitespace.

 -- Ondřej Surý <ondrej@debian.org>  Sun, 21 Jul 2024 08:39:12 +0200

tidy-html5 (2:5.8.0-1~exp3) experimental; urgency=medium

  * debian/watch: Fix monitoring script.

 -- Boyuan Yang <byang@debian.org>  Fri, 22 Apr 2022 21:44:01 -0400

tidy-html5 (2:5.8.0-1~exp2) experimental; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit.

  [ Boyuan Yang ]
  * debian/control: Bump Standards-Version to 4.6.0.
  * debian/control: Fix indent.

 -- Boyuan Yang <byang@debian.org>  Fri, 22 Apr 2022 21:41:05 -0400

tidy-html5 (2:5.8.0-1~exp1) experimental; urgency=medium

  * New upstream stable release.
  * debian/control:
    + Bump SONAME to 58.

 -- Boyuan Yang <byang@debian.org>  Tue, 13 Jul 2021 15:13:45 -0400

tidy-html5 (2:5.7.45-1~exp1) experimental; urgency=medium

  * New upstream interim release as suggested by upstream.
  * debian/control:
    + Bump Standards-Version to 4.5.1.
    + Bump debhelper compat to v13.
  * debian/rules:
    - Drop override for dh_missing, now default in dh13.
    + Use dh13 syntax.
  * debian/patches: Drop all backported patches, merged upstream.
  * debian/libtidy5deb1.symbols: Refresh symbols.

 -- Boyuan Yang <byang@debian.org>  Fri, 26 Mar 2021 13:31:46 -0400

tidy-html5 (2:5.6.0-11) unstable; urgency=medium

  * Rebuild for Ubuntu 20.04 LTS.

  [ Debian Janitor ]
  * Drop no longer supported add-log-mailing-address setting from
    debian/changelog.
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.
  * Update standards version to 4.4.1, no changes needed.

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Jan 2020 13:22:18 -0800

tidy-html5 (2:5.6.0-10) unstable; urgency=medium

  * Rebuild for Debian Buster.

  [ Boyuan Yang ]
  * debian/control:
    + Bump debhelper compat to v12.
    + Bump Standards-Version to 4.3.0.

  [ Viktor Szépe ]
  * debian/control: Fix grammar in package description.

 -- Boyuan Yang <byang@debian.org>  Thu, 28 Feb 2019 16:14:05 -0500

tidy-html5 (2:5.6.0-9) unstable; urgency=medium

  * debian/patches:
    - Drop debian-specific patch to revert issue-679 patch,
      libhtml-tidy-perl has made a new upload to address the
      issue downstream.
    + Cherry-pick upstream patch for upstream issue-697 and
      issue-712 (5.7.10 and 5.7.11 fix).
  * debian/symbols:
    + Add a Build-Depends-Package field as suggested by lintian.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Nov 2018 19:58:50 -0500

tidy-html5 (2:5.6.0-8) unstable; urgency=medium

  * debian/patches:
    + Rearrange patch series to follow upstream commit order.
    + Add a patch to partially revert upstream issue-679 patch to avoid
      an unnecessary breaking behaviour for css-prefix. This fixes an
      autopkgtest regression in libhtml-tidy-perl.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Nov 2018 11:08:12 -0500

tidy-html5 (2:5.6.0-7) unstable; urgency=medium

  * debian/rules:
    + Apply build workaround to fix FTCBFS due to man page generation.
      (Closes: #875429).
  * debian/control:
    + Drop useless ${shlibs:Depends} substitution from libtidy-dev's
      build dependency list.
  * debian/patches:
    + Cherry-pick several upstream trunk patches till tidy-html5 5.7.8.
      (Upstream 5.7.9 changeset is implemented in Debian-specific patch)

 -- Boyuan Yang <byang@debian.org>  Wed, 14 Nov 2018 22:15:20 -0500

=== debian/control ===
Source: tidy-html5
Section: web
Priority: optional
Maintainer: Tidy HTML5 <tidy-html5@packages.debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               xsltproc,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://www.html-tidy.org/
Vcs-Git: https://salsa.debian.org/debian/tidy-html5.git
Vcs-Browser: https://salsa.debian.org/debian/tidy-html5

Package: libtidy-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libtidy58 (= ${binary:Version}),
         ${misc:Depends},
Suggests: libdmalloc-dev
Breaks: libtidy-0.99-0
Replaces: libtidy-0.99-0
Description: HTML/XML syntax checker and reformatter - development
 Tidy corrects and cleans up HTML and XML documents by fixing
 markup errors and upgrading legacy code to modern standards.
 .
 This package contains the libtidy static library and the headers.

Package: libtidy58
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: HTML/XML syntax checker and reformatter - shared library
 Tidy corrects and cleans up HTML and XML documents by fixing
 markup errors and upgrading legacy code to modern standards.
 .
 This package contains the libtidy shared library.

Package: tidy
Architecture: any
Depends: libtidy58 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: HTML/XML syntax checker and reformatter
 Tidy corrects and cleans up HTML and XML documents by fixing
 markup errors and upgrading legacy code to modern standards.
 .
 This package contains a command line tool 'tidy'.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/htacg/tidy-html5/tags \
 (?:.*?/)?v?(\d\.[02468]\.\d)@ARCHIVE_EXT@
